\chapter{Modbat \& ZooKeeper}
Here, starting from nothing, a simple model of the ZooKeeper service is created from the documentation.
 Although this is well-made for a normal use of the software,
 but the documentation of the development part is really poor,
 and sometimes does not exists for some functions.
 However numerous examples and J unit tests exist to understand how ZooKeeper works.

	\section{A simple model}
ZooKeeper can handle a lot of servers with several connections.
 In this model, only one server server will handle several connections,
 each of them modelled by a client.
 This simplification will help to understand more easily how ZooKeeper behaves.

		\subsection{The server}
The model of the server will be very simple, after an initial state where the model configure:
\begin{itemize}
\item {\bfseries the number of connections}: the maximum number of clients the server can handle.
\item {\bfseries the tick time}: the basic time unit in milliseconds used by ZooKeeper. It is used to do heartbeats and the minimum session time-out will be twice the tickTime.
\item {\bfseries the data directory}: the location to store the in-memory database snapshots and, unless specified otherwise, the transaction log of updates to the database.
\item {\bfseries the port of connection}: the port to listen for client connections.
\end{itemize}
The server will start and launch randomly several clients before disconnecting.
 Of course we can configure other option in the initial state but the model will ignore it for the moment.

\begin{figure}[h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/ServerModel.pdf}
\caption{Model of the stand alone server}
\end{figure}

		\subsection{The clients}
In ZooKeeper, the connection behavior of the client should look like the figure 4.2.
 And once a client is in the state "connected", he can perform one of the seven actions allowed.
 But again, in order to simplify it, a simplified model was created.
 In this model, the client will just try to be connected to the server,
 and once connected, performed some writing and reading actions before disconnecting.
 The model showed in the figure 4.3 is a simplified version which is more readable than the complete model shows in the figure 4.4.

\begin{figure}[h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/ClientConnectionModel.pdf}
\caption{Original model of the client connection}
\end{figure}

\begin{sidewaysfigure}
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/ClientModel.pdf}
\caption{Simplied model}
\end{sidewaysfigure}

\begin{sidewaysfigure}
\centering
\includegraphics[scale=0.33]{image/ChapterZooMod/ClientModelComplex.pdf}
\caption{Complex model}
\end{sidewaysfigure}

\clearpage

	\section{check and update of the model}
The main goal of this model is to check if the output of each action is correct.
 In order to perform this, the model must save some data to compare to the behavior of ZooKeeper.

		\subsection{database added}
So, to check that every actions is well-performed, a virtual copy of the server is created.
 The main problem here is the delay between the moment the data in the ZooKeeper service is updated,
 and the moment where our own data is updated. Indeed we can update our model only in two place,
 when a client call for an action, and when a client received the callback of this action.
 For the moment we will consider that our data base is updated when a client received his callback.

With the example of the figure 4.5, when a client performed a call,
 the model save in memory several variables that explain the actual state of the nodes concern by the action.
 and after the server perform the action,
 we check that the data save in our variables are coherent with the callback.

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/CheckVariable.pdf}
\caption{Example of checking}
\end{figure}
 
So for example a client call a writing action,
 the model save in memory several variables of the actual state of the node.
 If a client wants to delete a node,
 the model will save in boolean variables if the node exists and is empty.
 And after the server performed the action,
 the model compare his response with the variables that have been saved.
 With the same example, if the server send an NoNodeException,
 the model will assert that the variable which saved the information about the existence of the node,
 is set to false.

		\subsection{update of the database}
Although, it works well with only one client,
 but with several ones the model must face a lot of actions performed quickly.
 But during the delay between  time our data could change on the server side
 And in most cases, the data change between the call of the action and the callback.
 The figure 4.6 is the simple example of two clients, one who calls for a synchronous action and the other calls an asynchronous action.

The problem here is that the first client action is performed by the server between the call and the callback of the second client action.
 So the variables that we save to check the callback of the second client are not up to date any more,
 the data on the server side has been changed and will change the outcome of the second client action,
 but as the model is aware of this change only during the call and the callback of an action,
 the data base of the model does not change. And so, for the model the callback of the second client action is false.

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/MainProblem.pdf}
\caption{Error with a synchronous and asynchronous actions}
\end{figure}

Moreover with the asynchronous action, even if they are performed in the order for one client,
 when we have two clients, the model have nothing to know which action is performed first.
 Also, the model does not take in parameters client with different speed of connection,
 but at the end the problem remain the same,
 it's not possible to know when the server will perform the action.
 The figure 4.7 shows different case where the error in the model can not be see.

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/ManyProblems.pdf}
\caption{Others examples with errors}
\end{figure}

	\section{Pending is the solution?}
The main goal remains the same, checking, when it's possible, the result and that it is correct with the data of the model.
 But if an action occurred in the middle of another action, the result could change and the checking is not possible any more.
 So the model will just avoid to check the result when this kind of situation occurred.
 In order to identify these cases, tracking actions have been added in the model.

		\subsection{Principle}
The model implement two kinds of tracking actions:

The first one checks if any action is happening. For that, each time a client calls for an action,
 the model increments by one the pending item of the nodes that this action will change.
 And once the action is completed and the callback received,
 the pending item is decreasing by one.
 If the pending item is different than 0 when a client for an action,
 the model knows that another action is happening and could change the outcome of the current action.

The second one counts how many actions have been called.
 So this time the pending item for this tracking action only increases each time that a client calls an action.
 The model save this number when a client call for an action,
 and after it compares this variable to the value of the pending item during the callback of this same action.
 If the number is different, it is because another action occurred,
 and could change the outcome of the current action.

\begin{figure}[h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/PendingExplenation.pdf}
\caption{The tracking action}
\end{figure}

Both tracking actions are important in order to identify each case.
 The figure 4.9 show that sometimes, one tracking action can find a mistake and the other one not.

\begin{figure}[h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/ImportanceOfBothPending.pdf}
\caption{Importance of both tracking action}
\end{figure}


		\subsection{Checking and pending items}
It becomes hazardous to check the result for a lot of situations.
 But if too many of this situation occurred, maybe the model will not check anything any more.
 So the model need to be more precise when we must check or not a result, and hopefully,
 ZooKeeper allows only few actions. Simulate all possible outcome for a couple of action become easy to make by hand.
 The table 4.1 shows all the possible outcome, with this initial state:

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/DataAllAction.pdf}
\end{figure}

\begin{sidewaystable}
\centering
{\scriptsize
\input{image/ChapterZooMod/AllConflictTwoActions.tex}
}
\caption{Couple of actions}
\end{sidewaystable}

			\subsubsection{Add pending item}
As the table shows, the model identify several path where add a tracking action:
 The children path, the data of the path, the parent path and the current path.
 We add a pending only with the writing actions because,
 because they are the only ones which can change our data.
 So for each of them we will build a list that will save the tracking action for each of this path,
 except for the parent and current path, which are in the same list.

Each of them is important to make the difference between each reading action.
 The model add a tracking action on a path, it becomes evident if you try to call the reading action exists on a node,
 and if an action occurs on the path of this node, the result will be different.

The pathChildren is there for the reading action getChildren.
 Indeed it's quite difficult to identify if no actions is happening on the current node and on his children.
 For that each time we have a writing action on the node, we add a tracking action on his parent.

And finally, the 'data of the path' is there for the reading action getData.
 set data is a particular writing action because only the data inside the node change,
 so it does not change the outcome of the other reading actions.

\bigbreak
So at the end the model does the difference between actions in order to not avoid to many situation,
 add allow more often to check the data.For example if the model follow this table,
 if a client tries to call for the action create,
 it will add a tracking action for the current path,
 because if the action exists occurred, the node could exist or not.
 It will add a tracking action on the children path of the parent,
 because if the action getChildren occurred, the number of children may changed.
 It will add a tracking action on the data of the node, because if a setData occurred,
 the data may be set or not depending of the existence of the node.

The pending action that the model will add depends of the writing action,
 and it be resume with the table 4.2 which is extracted directly from the table 4.1.

\begin{table}[h]
\centering
{\scriptsize
\input{image/ChapterZooMod/AddPending.tex}
}
\caption{Add pending items depending of the writing action}
\end{table}

			\subsubsection{Checking}
So, after we add the pending item, the model will use them during the callback to see if it is safe to check the result.
 But for each actions, specific kind of tracking action will allow on not to check some data.
 For example if we have the reading action exists on a node,
 the model must be only aware if any action is happening on this node.
 Each action must be careful about specific pending items and can be resume in the table 4.3.

\begin{table}[h]
\centering
{\scriptsize
\input{image/ChapterZooMod/DependOfPending.tex}
}
\caption{Add pending items depending of the writing action}
\end{table}

			\subsubsection{A more precise checking}
But again this kind of checking is to large and the model could be more specific.
 For this goal the model must be aware of the response of the callback, and what action is really happening.
 For this purpose, it is not enough to say an action occurs on a node, now the action must be specified too.
 At the end we obtain the table 4.4 which extracted from our main table, the table 4.1.

 This table can be read this way: for example, a client calls a create action,
 the callback said that the action went well and has been performed(OK).
 So if the result  must be checked, no delete action on the current path of the node must occurred,
 indeed if the model want to assert that the node did not exists before this action,
 no delete action must happened during this time.
 Moreover no create action must happening with the parent of this node,
 every part of this table is explainable with the Table 4.1.
\begin{table}[h]
\centering
{\scriptsize
\input{image/ChapterZooMod/PrecisePending.tex}
}
\caption{Precise table of pending}
\end{table}

	\section{Saving the data}
Each time, to perform a check the model must compare the date of the ZooKeeper service with the model's data.
 However it is not simple because of the delay between the call and when the action is performed by the server,
 and the time that the callback takes to arrive to the client. In order to check something,
 we must be sure that the data saved by the model is the same that the ZooKeeper service.

In a first place, the main idea was to update the model during the callback,
 but even if the model do not simulate client with different connection speed,
 if the situation in the figure 4.10 occurred,
 it's easy to see that the data between the model and the ZooKeeper service will be different.
 But this is not the only situation where it happens, so the resolution of this mistake became important.

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/ProblemUpdate.pdf}
\caption{Problem of update}
\end{figure}

		\subsection{when save the data?}

So we have still only two places where update the data of the model,
 before the call of the action, and after the callback.
 Change the data before calling the action is not possible too,
 because we do not know the outcome and a node, for example, may be created or not.

The figure 4.11 show two asynchronous actions performed by two different clients.
 Here, the server will perform these actions in one thread but it is no possible for the model to know which one will be performed first.
 At the end, the node may be created or not. If the model choose to create the node,
 and just after the model try to delete this same node and send an exception because the node does not exists on the server side,
 the model will send an error because for his data the node exists.
 Same things if the model choose to not create the node and a client try to create a node in this same node.

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/StateUnknown.pdf}
\caption{Explenation of the state unknown}
\end{figure}

		\subsection{The state Unknown}
However we start with the hypothesis that all will works for the creation of a node,
 and before deleting a node the model will wait for the callback of the action.
 So when we call for a create action, if the node does not exists in the data of the model,
 the node will be created. But each time a client will call for a writing action,
 the nodes concerned by this action will be set to the state unknown by the model.

			\subsubsection{Checking with the state unknown}
In the previous example, the model create the node a the end but with the state unknown.
 So even if we try to delete this node and it's not successful,
 it means that the node does not exists in the ZooKeeper service,
 when the model will compare the result to his data model he will see that the existence of the node was uncertain,
 then the checking will be avoid.

			\subsubsection{Confirm existence}
Moreover sometimes the model have the capacity to remove this state unknown on a node.
 For example, with the simple action to create a node,
 if no delete action happens on this node or his parent,
 then the model can be sure that even if the node already exist,
 the node a the end will exists. The state unknown can be remove for this node

The table 4.5 shows what to do for every outcome of the writing action, and with other action that could happen.
 the number 1 means that we confirm that the node exists, the 0 means that it does not exists.
 The state i() means that before confirming with the existence i(1) or the non-existence i(0) of the node,
 the model must before confirming that the action that occurred in the same time does not concern the same path.
 Otherwise, the node stay with the state unknown.

\begin{table}[!h]
\centering
{\scriptsize
\input{image/ChapterZooMod/UnknownNode.tex}
}
\caption{Unknown Node}
\end{table}

Moreover if a node exists, then all these parents must existed too.
 So when the model confirm the existence of a node, it does the same for each of his parents.

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterZooMod/ConfirmCreate.pdf}
\caption{Special case of confirming the creation of a node}
\end{figure}

		\subsubsection{Confirm data}
Of course the data have also a state unknown,
 a very particular case when the model do not know if the data has been well set because the existence of the node is uncertain,
 but also when two clients try to change simultaneously the data of the node.
 For these case the model will do the same than create a node,
 it will apply the change when the client calls for the action setData.

The table 4.6 as the previous table shows what to do for each situation.
 the number 1 means that the model can check the data, df means that the data can be check and remove the file

\begin{table}[!h]
\centering
{\scriptsize
\input{image/ChapterZooMod/UnknownData.tex}
}
\caption{Unknown Data}
\end{table}